// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_visualization_msgs:msg/TexturedMarker.idl
// generated code does not contain a copyright notice
#include "marti_visualization_msgs/msg/textured_marker__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/header__functions.h"
// Member `ns`
#include "rosidl_generator_c/string_functions.h"
// Member `lifetime`
#include "builtin_interfaces/msg/duration__functions.h"
// Member `image`
#include "sensor_msgs/msg/image__functions.h"
// Member `pose`
#include "geometry_msgs/msg/pose__functions.h"

bool
marti_visualization_msgs__msg__TexturedMarker__init(marti_visualization_msgs__msg__TexturedMarker * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
    return false;
  }
  // ns
  if (!rosidl_generator_c__String__init(&msg->ns)) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
    return false;
  }
  // id
  // action
  // lifetime
  if (!builtin_interfaces__msg__Duration__init(&msg->lifetime)) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__init(&msg->image)) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
    return false;
  }
  // resolution
  // alpha
  return true;
}

void
marti_visualization_msgs__msg__TexturedMarker__fini(marti_visualization_msgs__msg__TexturedMarker * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // ns
  rosidl_generator_c__String__fini(&msg->ns);
  // id
  // action
  // lifetime
  builtin_interfaces__msg__Duration__fini(&msg->lifetime);
  // image
  sensor_msgs__msg__Image__fini(&msg->image);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // resolution
  // alpha
}

marti_visualization_msgs__msg__TexturedMarker *
marti_visualization_msgs__msg__TexturedMarker__create()
{
  marti_visualization_msgs__msg__TexturedMarker * msg = (marti_visualization_msgs__msg__TexturedMarker *)malloc(sizeof(marti_visualization_msgs__msg__TexturedMarker));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_visualization_msgs__msg__TexturedMarker));
  bool success = marti_visualization_msgs__msg__TexturedMarker__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_visualization_msgs__msg__TexturedMarker__destroy(marti_visualization_msgs__msg__TexturedMarker * msg)
{
  if (msg) {
    marti_visualization_msgs__msg__TexturedMarker__fini(msg);
  }
  free(msg);
}


bool
marti_visualization_msgs__msg__TexturedMarker__Sequence__init(marti_visualization_msgs__msg__TexturedMarker__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_visualization_msgs__msg__TexturedMarker * data = NULL;
  if (size) {
    data = (marti_visualization_msgs__msg__TexturedMarker *)calloc(size, sizeof(marti_visualization_msgs__msg__TexturedMarker));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_visualization_msgs__msg__TexturedMarker__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_visualization_msgs__msg__TexturedMarker__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_visualization_msgs__msg__TexturedMarker__Sequence__fini(marti_visualization_msgs__msg__TexturedMarker__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_visualization_msgs__msg__TexturedMarker__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_visualization_msgs__msg__TexturedMarker__Sequence *
marti_visualization_msgs__msg__TexturedMarker__Sequence__create(size_t size)
{
  marti_visualization_msgs__msg__TexturedMarker__Sequence * array = (marti_visualization_msgs__msg__TexturedMarker__Sequence *)malloc(sizeof(marti_visualization_msgs__msg__TexturedMarker__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_visualization_msgs__msg__TexturedMarker__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_visualization_msgs__msg__TexturedMarker__Sequence__destroy(marti_visualization_msgs__msg__TexturedMarker__Sequence * array)
{
  if (array) {
    marti_visualization_msgs__msg__TexturedMarker__Sequence__fini(array);
  }
  free(array);
}
