#ifndef _H_3DFDE3A5B39312C9772E33F1203DA665_TexturedMarker__H_
#define _H_3DFDE3A5B39312C9772E33F1203DA665_TexturedMarker__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"
#include "sensor_msgs/msg/dds_opensplice/Image_.h"
#include "geometry_msgs/msg/dds_opensplice/Pose_.h"


namespace marti_visualization_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TexturedMarker_Constants
            {
                const ::DDS::Octet ADD_ = 0;

                const ::DDS::Octet MODIFY_ = 0;

                const ::DDS::Octet DELETE_ = 2;

            }

            struct  TexturedMarker_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::String_mgr ns_;
                ::DDS::Long id_;
                ::DDS::Long action_;
                ::builtin_interfaces::msg::dds_::Duration_ lifetime_;
                ::sensor_msgs::msg::dds_::Image_ image_;
                ::geometry_msgs::msg::dds_::Pose_ pose_;
                ::DDS::Double resolution_;
                ::DDS::Float alpha_;
            };

            typedef DDS_DCPSStruct_var<TexturedMarker_> TexturedMarker__var;
            typedef DDS_DCPSStruct_out < TexturedMarker_> TexturedMarker__out;

        }

    }

}

#endif /* _H_3DFDE3A5B39312C9772E33F1203DA665_TexturedMarker__H_ */
